diff -uwr source/scripts/jfwmisc.h 4.0/source/scripts/jfwmisc.h
--- source/scripts/jfwmisc.h	2011-02-18 22:55:26.000000000 +0800
+++ 4.0/source/scripts/jfwmisc.h	2011-10-22 19:58:24.060546800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Miscellanious scripts
-	Copyright 2010 Vloktboky, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_User_Settable_Parameters : public ScriptImpClass {
 	void Created(GameObject *obj);
 };
@@ -273,3 +273,135 @@
 class JFW_Points_Custom : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
+
+class JFW_Display_String_Custom : public ScriptImpClass {
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
+class JFW_Preset_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_Power_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_Radar_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_Conyard_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_Refinery_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_VehicleFactory_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_AirFactory_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
+class JFW_Engineer_Hack : public ScriptImpClass {
+	unsigned int Warhead;
+	int IndcatorID;
+	float HackHealth;
+	void Created(GameObject *obj);
+	void Killed(GameObject *obj,GameObject *killer);
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+	void Timer_Expired(GameObject *obj,int number);
+	void Apply_Damage(GameObject *obj,float damage);
+	void Apply_Repair(GameObject *obj,float repair);
+};
+
+class JFW_Double_Animation : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
+class JFW_EMP : public ScriptImpClass {
+	unsigned int Warhead;
+	void Created(GameObject *obj);
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+class JFW_EMP_Mine : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Enemy_Seen(GameObject *obj,GameObject *enemy);
+	void Destroyed(GameObject *obj);
+};
+
+class JFW_EMP_Mine_Manager : public ScriptImpClass {
+	int mines;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
+class JFW_EMP_Mine_Layer : public ScriptImpClass {
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+};
+
+class JFW_Radar_Disable_Death : public ScriptImpClass {
+	void Killed(GameObject *obj,GameObject *killer);
+};
+
+class JFW_Cyborg_Reaper : public ScriptImpClass {
+	int driverid;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+};
+
+class JFW_Limpet_Drone : public ScriptImpClass {
+	bool stealth;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
+class JFW_Forward_Custom_Object : public ScriptImpClass {
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
+class JFW_Death_Send_Custom_Self : public ScriptImpClass {
+	void Killed(GameObject *obj,GameObject *killer);
+};
+
+class JFW_Hunter_Seeker : public JFW_Key_Hook_Base {
+	int driverid;
+	void Created(GameObject *obj);
+	void KeyHook();
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+class JFW_Ion_Storm : public ScriptImpClass {
+	bool storm;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
diff -uwr source/scripts/jfwobj.cpp 4.0/source/scripts/jfwobj.cpp
--- source/scripts/jfwobj.cpp	2010-08-21 21:45:50.000000000 +0800
+++ 4.0/source/scripts/jfwobj.cpp	2011-10-11 23:05:09.706054600 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that deal with objectives and single player stuff
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwobj.h 4.0/source/scripts/jfwobj.h
--- source/scripts/jfwobj.h	2010-04-14 10:13:26.000000000 +0800
+++ 4.0/source/scripts/jfwobj.h	2011-10-14 22:27:32.083007800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that deal with objectives and single player stuff
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Add_Objective : public ScriptImpClass {
 	float timertime;
 	int timernumber;
diff -uwr source/scripts/jfwpoke.cpp 4.0/source/scripts/jfwpoke.cpp
--- source/scripts/jfwpoke.cpp	2010-05-21 09:42:38.000000000 +0800
+++ 4.0/source/scripts/jfwpoke.cpp	2011-10-11 23:05:08.540039000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that can be poked
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwpoke.h 4.0/source/scripts/jfwpoke.h
--- source/scripts/jfwpoke.h	2010-05-21 09:42:38.000000000 +0800
+++ 4.0/source/scripts/jfwpoke.h	2011-10-14 22:27:32.035156200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that can be poked
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Poke_Send_Custom : public ScriptImpClass {
 	int active;
 	void Created(GameObject *obj);
diff -uwr source/scripts/jfwpow.cpp 4.0/source/scripts/jfwpow.cpp
--- source/scripts/jfwpow.cpp	2010-04-14 10:13:20.000000000 +0800
+++ 4.0/source/scripts/jfwpow.cpp	2011-10-11 23:05:01.913085900 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that deal with powerups
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwpow.h 4.0/source/scripts/jfwpow.h
--- source/scripts/jfwpow.h	2010-04-14 10:13:26.000000000 +0800
+++ 4.0/source/scripts/jfwpow.h	2011-10-14 22:27:32.207031200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that deal with powerups
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Spawn_Timer : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Timer_Expired(GameObject *obj,int number);
diff -uwr source/scripts/jfwscr.cpp 4.0/source/scripts/jfwscr.cpp
--- source/scripts/jfwscr.cpp	2010-04-14 10:13:20.000000000 +0800
+++ 4.0/source/scripts/jfwscr.cpp	2011-10-11 23:05:07.345703100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that attach and remove other scripts
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwscr.h 4.0/source/scripts/jfwscr.h
--- source/scripts/jfwscr.h	2010-04-14 10:13:26.000000000 +0800
+++ 4.0/source/scripts/jfwscr.h	2011-10-14 22:27:32.158203100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that attach and remove other scripts
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Attatch_Script : public ScriptImpClass {
 	void Killed(GameObject *obj,GameObject *killer);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
diff -uwr source/scripts/jfwsnd.cpp 4.0/source/scripts/jfwsnd.cpp
--- source/scripts/jfwsnd.cpp	2010-07-16 10:53:20.000000000 +0800
+++ 4.0/source/scripts/jfwsnd.cpp	2011-10-11 23:05:06.098632800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that play sounds
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwsnd.h 4.0/source/scripts/jfwsnd.h
--- source/scripts/jfwsnd.h	2010-04-14 10:13:26.000000000 +0800
+++ 4.0/source/scripts/jfwsnd.h	2011-10-14 22:27:31.957031200 +0800
@@ -1,6 +1,5 @@
 /* Renegade Scripts.dll
-	Scripts that play sounds
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_2D_Sound_Timer : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
diff -uwr source/scripts/jfwveh.cpp 4.0/source/scripts/jfwveh.cpp
--- source/scripts/jfwveh.cpp	2011-05-19 15:26:00.000000000 +0800
+++ 4.0/source/scripts/jfwveh.cpp	2011-10-11 23:05:04.906250000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for vehicles
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwveh.h 4.0/source/scripts/jfwveh.h
--- source/scripts/jfwveh.h	2010-04-14 10:14:46.000000000 +0800
+++ 4.0/source/scripts/jfwveh.h	2011-10-14 22:27:32.110351500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for vehicles
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Aircraft_Fuel : public ScriptImpClass {
 	bool entered;
 	void Created(GameObject *obj);
diff -uwr source/scripts/jfwweap.cpp 4.0/source/scripts/jfwweap.cpp
--- source/scripts/jfwweap.cpp	2010-08-13 14:35:06.000000000 +0800
+++ 4.0/source/scripts/jfwweap.cpp	2011-10-11 23:05:03.604492100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Weapon scripts
-	Copyright 2010 Olaf Van Der Spek, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwweap.h 4.0/source/scripts/jfwweap.h
--- source/scripts/jfwweap.h	2010-04-14 10:13:26.000000000 +0800
+++ 4.0/source/scripts/jfwweap.h	2011-10-14 22:27:32.059570300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Weapon scripts
-	Copyright 2010 Olaf Van Der Spek, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Nod_Turret : public ScriptImpClass {
 	unsigned int id1;
 	unsigned int id2;
diff -uwr source/scripts/jfwws.cpp 4.0/source/scripts/jfwws.cpp
--- source/scripts/jfwws.cpp	2011-06-14 23:05:12.000000000 +0800
+++ 4.0/source/scripts/jfwws.cpp	2011-10-11 23:04:59.768554600 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Westwood script clones
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -412,9 +411,9 @@
 void JFW_BuildingStateSoundSpeaker::Created(GameObject *obj)
 {
 	destroyed = false;
-	var3 = true;
+	explode = true;
 	GameObject *object = Commands->Find_Object(Get_Int_Parameter("BuildingController_ID"));
-	if (obj)
+	if (object)
 	{
 		char s[18];
 		sprintf(s,"%d",Commands->Get_ID(obj));
@@ -433,95 +432,100 @@
 
 void JFW_BuildingStateSoundSpeaker::Custom(GameObject *obj,int type,int param,GameObject *sender)
 {
-	if (type == CUSTOM_EVENT_SOUND_ENDED)
+	switch (type)
 	{
-		float min = 0;
-		float max = 0;
-		if (!destroyed)
+	case CUSTOM_EVENT_SOUND_ENDED:
+		if (destroyed)
 		{
-			if (Get_Int_Parameter("Frequency_Min") != -1)
+			if (Get_Int_Parameter("Frequency_Min_Destroyed") != -1)
 			{
-				min = Get_Float_Parameter("Frequency_Min");
-				max = Get_Float_Parameter("Frequency_Max");
+				float min = Get_Float_Parameter("Frequency_Min_Destroyed");
+				float max = Get_Float_Parameter("Frequency_Max_Destroyed");
+				float frequency = Commands->Get_Random(min,max);
+				Commands->Start_Timer(obj,this,frequency,0);
 			}
 		}
 		else
 		{
 			if (Get_Int_Parameter("Frequency_Min") != -1)
 			{
-				min = Get_Float_Parameter("Frequency_Min_Destroyed");
-				max = Get_Float_Parameter("Frequency_Max_Destroyed");
-			}
-		}
+				float min = Get_Float_Parameter("Frequency_Min");
+				float max = Get_Float_Parameter("Frequency_Max");
 		float frequency = Commands->Get_Random(min,max);
 		Commands->Start_Timer(obj,this,frequency,0);
 	}
-	if ((type == 9026) && (param == 1))
+		}
+		break;
+	case 9026:
+		if (param == 1)
 	{
 		Commands->Stop_Sound(sound,1);
+			destroyed = true;
 		Timer_Expired(obj,0);
 	}
-	if ((type == 9027) && (var3))
+		break;
+	case 9027:
+		if (explode)
 	{
 		Vector3 v = Commands->Get_Position(obj);
 		v.X += Commands->Get_Random(2.0,5.0);
 		v.Y += Commands->Get_Random(2.0,5.0);
 		v.Z += Commands->Get_Random(2.0,5.0);
 		Commands->Create_Explosion(Get_Parameter("Explosion_Name"),v,0);
-		Commands->Send_Custom_Event(obj,obj,type,1,Commands->Get_Random(3.0,6.0));
+			Commands->Send_Custom_Event(obj,obj,9027,1,Commands->Get_Random(3.0,6.0));
 	}
-	if (type == 9028)
-	{
-		var3 = false;
-	}
-	if (type == 9029)
-	{
-		var3 = true;
+		break;
+	case 9028:
+		explode = false;
+		break;
+	case 9029:
+		explode = true;
+		break;
 	}
 }
 
 void JFW_BuildingStateSoundSpeaker::Timer_Expired(GameObject *obj,int number)
 {
-	if (!destroyed)
+	if (destroyed)
 	{
-		bool is3d = Get_Int_Parameter("Is_3D");
+		bool is3d = Get_Int_Parameter("Is_3D_Destroyed");
 		Vector3 pos = Commands->Get_Position(obj);
-		Vector3 offset = Get_Vector3_Parameter("Offset");
+		Vector3 offset = Get_Vector3_Parameter("Offset_Destroyed");
 		pos.X += offset.X;
 		pos.Y += offset.Y;
 		pos.Z += offset.Z;
-		offset = Get_Vector3_Parameter("Offset_Randomness");
+		offset = Get_Vector3_Parameter("Offset_Randomness_Destroyed");
 		pos.X += Commands->Get_Random(offset.X,-offset.X);
 		pos.Y += Commands->Get_Random(offset.Y,-offset.Y);
 		pos.Z += Commands->Get_Random(offset.Z,-offset.Z);
 		if (is3d)
 		{
-			sound = Commands->Create_Sound(Get_Parameter("Sound_Normal"),pos,obj);
+			sound = Commands->Create_Sound(Get_Parameter("Sound_Destroyed"),pos,obj);
 		}
 		else
 		{
-			sound = Commands->Create_2D_Sound(Get_Parameter("Sound_Normal"));
+			sound = Commands->Create_2D_Sound(Get_Parameter("Sound_Destroyed"));
 		}
 	}
 	else
 	{
-		bool is3d = Get_Int_Parameter("Is_3D_Destroyed");
+		bool is3d = Get_Int_Parameter("Is_3D");
 		Vector3 pos = Commands->Get_Position(obj);
-		Vector3 offset = Get_Vector3_Parameter("Offset_Destroyed");
+		Vector3 offset = Get_Vector3_Parameter("Offset");
 		pos.X += offset.X;
 		pos.Y += offset.Y;
 		pos.Z += offset.Z;
-		offset = Get_Vector3_Parameter("Offset_Randomness_Destroyed");
+		offset = Get_Vector3_Parameter("Offset_Randomness");
 		pos.X += Commands->Get_Random(offset.X,-offset.X);
 		pos.Y += Commands->Get_Random(offset.Y,-offset.Y);
 		pos.Z += Commands->Get_Random(offset.Z,-offset.Z);
 		if (is3d)
 		{
-			sound = Commands->Create_Sound(Get_Parameter("Sound_Destroyed"),pos,obj);
+			sound = Commands->Create_Sound(Get_Parameter("Sound_Normal"),pos,obj);
 		}
 		else
 		{
-			sound = Commands->Create_2D_Sound(Get_Parameter("Sound_Destroyed"));
+			sound = Commands->Create_2D_Sound(Get_Parameter("Sound_Normal"));
 		}
 	}
 	Commands->Monitor_Sound(obj,sound);
@@ -555,7 +559,7 @@
 		GameObject *object = Commands->Find_Object(speakerid);
 		if (object)
 		{
-			Commands->Send_Custom_Event(obj,object,type,1,0);
+			Commands->Send_Custom_Event(obj,object,9028,1,0);
 		}
 	}
 	if (type == 9029)
@@ -563,7 +567,7 @@
 		GameObject *object = Commands->Find_Object(speakerid);
 		if (object)
 		{
-			Commands->Send_Custom_Event(obj,object,type,1,0);
+			Commands->Send_Custom_Event(obj,object,9029,1,0);
 		}
 	}
 }
@@ -703,6 +707,8 @@
 ScriptRegistrant<JFW_PlayAnimation_DestroyObject> JFW_PlayAnimation_DestroyObject_Registrant("JFW_PlayAnimation_DestroyObject","AnimationName:string");
 ScriptRegistrant<JFW_BuildingStateSoundSpeaker> JFW_BuildingStateSoundSpeaker_Registrant("JFW_BuildingStateSoundSpeaker","Sound_Normal:string,Sound_Destroyed:string,BuildingController_ID:int,Is_3D=1:int,Offset:vector3,Offset_Randomness:vector3,Frequency_Min=-1:float,Frequency_Max:float,Is_3D_Destroyed=1:int,Offset_Destroyed:vector3,Offset_Randomness_Destroyed:vector3,Frequency_Min_Destroyed=-1:float,Frequency_Max_Destroyed:float,Explosion_Name:string");
 ScriptRegistrant<JFW_BuildingStateSoundController> JFW_BuildingStateSoundController_Registrant("JFW_BuildingStateSoundController","BuildingSpeaker_ID:int");
+ScriptRegistrant<JFW_BuildingStateSoundSpeaker> M00_BuildingStateSoundSpeaker_Registrant("M00_BuildingStateSoundSpeaker","Sound_Normal:string,Sound_Destroyed:string,BuildingController_ID:int,Is_3D=1:int,Offset:vector3,Offset_Randomness:vector3,Frequency_Min=-1:float,Frequency_Max:float,Is_3D_Destroyed=1:int,Offset_Destroyed:vector3,Offset_Randomness_Destroyed:vector3,Frequency_Min_Destroyed=-1:float,Frequency_Max_Destroyed:float,Explosion_Name:string");
+ScriptRegistrant<JFW_BuildingStateSoundController> M00_BuildingStateSoundController_Registrant("M00_BuildingStateSoundController","BuildingSpeaker_ID:int");
 ScriptRegistrant<JFW_Play_Sound_Object_Bone> JFW_Play_Sound_Object_Bone_Registrant("JFW_Play_Sound_Object_Bone","Sound_Preset:string,Frequency_Min=-1.0:float,Frequency_Max:float");
 ScriptRegistrant<JFW_Cinematic_Primary_Killed> JFW_Cinematic_Primary_Killed_Registrant("JFW_Cinematic_Primary_Killed","CallbackID=:int");
 ScriptRegistrant<JFW_Disable_Loiter> JFW_Disable_Loiter_Registrant("JFW_Disable_Loiter","");
diff -uwr source/scripts/jfwws.h 4.0/source/scripts/jfwws.h
--- source/scripts/jfwws.h	2011-06-14 23:05:12.000000000 +0800
+++ 4.0/source/scripts/jfwws.h	2011-10-14 22:27:32.002929600 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Westwood script clones
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Building_Explode_No_Damage : public ScriptImpClass {
 	void Killed(GameObject *obj,GameObject *killer);
 };
@@ -141,7 +141,7 @@
 class JFW_BuildingStateSoundSpeaker : public ScriptImpClass {
 	unsigned int sound;
 	bool destroyed;
-	bool var3;
+	bool explode;
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Timer_Expired(GameObject *obj,int number);
diff -uwr source/scripts/jfwzone.cpp 4.0/source/scripts/jfwzone.cpp
--- source/scripts/jfwzone.cpp	2011-06-10 17:38:14.000000000 +0800
+++ 4.0/source/scripts/jfwzone.cpp	2011-10-25 16:01:41.291015600 +0800
@@ -1,13 +1,12 @@
 /*	Renegade Scripts.dll
-	Zone related scripts
-	Copyright 2010 Tom "Dante" Anderson, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
 	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #include "general.h"
@@ -22,6 +21,7 @@
 #include "ConstructionYardGameObj.h"
 #include "VehicleGameObjDef.h"
 #include "BuildingGameObjDef.h"
+#include "dp88_custom_timer_defines.h"
 
 void JFW_3D_Sound_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
@@ -2093,7 +2093,7 @@
 	if ((Is_Building_Dead(Find_Com_Center(Commands->Get_Player_Type(enterer))) && (Is_Radar_Enabled(PTTEAM(Commands->Get_Player_Type(enterer))))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),Commands->Get_Player_Type(enterer));
-		Enable_Base_Radar(Commands->Get_Player_Type(enterer),true);
+		Enable_Base_Radar(Get_Object_Type(enterer),true);
 		reset = true;
 	}
 }
@@ -2507,9 +2507,9 @@
 			const char *preset = Commands->Get_Preset_Name(Commands->Find_Object(ID));
 			float cost = ((float)Get_Cost(preset) / 2);
 			Commands->Give_Money(Get_Vehicle_Driver(Commands->Find_Object(ID)),cost,false);
+			Commands->Send_Custom_Event(Owner(),Commands->Find_Object(ID),CUSTOM_ENTERED_VTOL_LAND_ZONE,0,0);
 			Force_Occupants_Exit(Commands->Find_Object(ID));
-			Commands->Destroy_Object(Commands->Find_Object(ID));
-			ID = 0;
+			Commands->Start_Timer(Owner(),this,1,1);
 			RemoveHook();
 		}
 	}
@@ -2525,6 +2525,12 @@
 	ID = 0;
 }
 
+void JFW_Sell_Zone::Timer_Expired(GameObject *obj,int number)
+{
+	Commands->Destroy_Object(Commands->Find_Object(ID));
+	ID = 0;
+}
+
 void JFW_Infantry_Force_Composition_Zone::Created(GameObject *obj)
 {
 	reset = false;
diff -uwr source/scripts/jfwzone.h 4.0/source/scripts/jfwzone.h
--- source/scripts/jfwzone.h	2011-04-25 18:31:38.000000000 +0800
+++ 4.0/source/scripts/jfwzone.h	2011-10-23 10:40:52.437500200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Zone related scripts
-	Copyright 2010 Tom "Dante" Anderson, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_3D_Sound_Zone : public ScriptImpClass {
 	void Entered(GameObject *obj,GameObject *enterer);
 };
@@ -409,6 +409,7 @@
 	void Entered(GameObject *obj,GameObject *enterer);
 	void Exited(GameObject *obj,GameObject *exiter);
 	void KeyHook();
+	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
 
